## ros-noetic-septentrio-gnss-driver 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(septentrio_gnss_driver)

## Compile as C++14, supported in ROS Melodic and newer
add_compile_options(-std=c++14)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  cpp_common
  rosconsole
  roscpp
  roscpp_serialization
  rostime
  xmlrpcpp
  nmea_msgs
  sensor_msgs
  geometry_msgs
  nav_msgs
  diagnostic_msgs
  gps_common
  message_generation
  tf2
  tf2_eigen
  tf2_geometry_msgs
  tf2_ros
)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED) # bug with 1.71: spirit is not found ... COMPONENTS system thread regex spirit)
LIST(APPEND CMAKE_MODULE_PATH "/usr/share/cmake/geographiclib")
find_package(GeographicLib REQUIRED)

## For PCAP file handling
find_library(libpcap_LIBRARIES pcap)
if ("${libpcap_LIBRARIES}" STREQUAL "pcap-NOTFOUND")
    set(libpcap_FOUND FALSE)
else ()
    set(libpcap_FOUND TRUE)
endif ()

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend tag for "message_generation"
##   * add a build_depend and a exec_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependency has been pulled in
##     but can be declared for certainty nonetheless:
##     * add a exec_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
add_message_files(
   FILES
   BaseVectorCart.msg
   BaseVectorGeod.msg
   BlockHeader.msg
   MeasEpoch.msg
   MeasEpochChannelType1.msg
   MeasEpochChannelType2.msg
   PVTCartesian.msg
   PVTGeodetic.msg
   PosCovCartesian.msg
   PosCovGeodetic.msg
   ReceiverTime.msg
   VelCovCartesian.msg
   VelCovGeodetic.msg
   AttEuler.msg
   AttCovEuler.msg
   INSNavCart.msg
   INSNavGeod.msg
   IMUSetup.msg
   VectorInfoCart.msg
   VectorInfoGeod.msg
   VelSensorSetup.msg
   ExtSensorMeas.msg
)

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
    DEPENDENCIES
    std_msgs
    sensor_msgs
    diagnostic_msgs
    gps_common
)

################################################
## Declare ROS dynamic reconfigure parameters ##
################################################

## To declare and build dynamic reconfigure parameters within this
## package, follow these steps:
## * In the file package.xml:
##   * add a build_depend and a exec_depend tag for "dynamic_reconfigure"
## * In this file (CMakeLists.txt):
##   * add "dynamic_reconfigure" to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * uncomment the "generate_dynamic_reconfigure_options" section below
##     and list every .cfg file to be processed

## Generate dynamic reconfigure parameters in the 'cfg' folder
# generate_dynamic_reconfigure_options(
#   cfg/DynReconf1.cfg
#   cfg/DynReconf2.cfg
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
   INCLUDE_DIRS include
   LIBRARIES 
   CATKIN_DEPENDS cpp_common rosconsole roscpp roscpp_serialization rostime xmlrpcpp message_runtime
   DEPENDS Boost
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${GeographicLib_INCLUDE_DIRS}
)

## Add cmake target dependencies of the library
## as an example, code may need to be generated before libraries
## either from message generation or dynamic reconfigure
# add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Declare a C++ executable
## With catkin_make all packages are built within a single CMake context
## The recommended prefix ensures that target names across packages don't collide
add_executable(${PROJECT_NAME}_node 
    src/septentrio_gnss_driver/node/main.cpp
    src/septentrio_gnss_driver/node/rosaic_node.cpp
    src/septentrio_gnss_driver/communication/circular_buffer.cpp 
    src/septentrio_gnss_driver/parsers/parsing_utilities.cpp 
    src/septentrio_gnss_driver/parsers/string_utilities.cpp 
    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgga.cpp 
    src/septentrio_gnss_driver/parsers/nmea_parsers/gprmc.cpp 
    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsa.cpp 
    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsv.cpp 
    src/septentrio_gnss_driver/crc/crc.cpp
    src/septentrio_gnss_driver/communication/communication_core.cpp 
    src/septentrio_gnss_driver/communication/rx_message.cpp 
    src/septentrio_gnss_driver/communication/callback_handlers.cpp
    src/septentrio_gnss_driver/communication/pcap_reader.cpp
)

## Rename C++ executable without prefix
## The above recommended prefix causes long target names, the following renames the
## target back to the shorter version for ease of user use
## e.g. "rosrun someones_pkg node" instead of "rosrun someones_pkg someones_pkg_node"
# set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")

## Add cmake target dependencies of the executable
## same as for the library above
add_dependencies(${PROJECT_NAME}_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}_node 
   ${catkin_LIBRARIES}
   ${Boost_LIBRARIES} 
   ${libpcap_LIBRARIES}
   ${GeographicLib_LIBRARIES}
)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executables for installation
## See http://docs.ros.org/melodic/api/catkin/html/howto/format1/building_executables.html
install(TARGETS ${PROJECT_NAME}_node
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

## Mark other files or directories for installation (e.g. launch and bag files, etc.)
install(DIRECTORY config launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-noetic-septentrio-gnss-driver (1.2.3-1buster) buster; urgency=high

  * New Features
    
    Twist output option
    
    Example config files for GNSS and INS
    
    Get leap seconds from receiver
    
    Firmware check
    
    VSM from odometry or twist ROS messages
    
    Add receiver type in case INS is used in GNSS mode
    
    Add publishing of base vector topics
  * Improvements
    
    Rework RTK corrections parameters and improve flexibility
  * Fixes
    
    /tf not being published without /localization
    
    Twist covariance matrix of localization
    
    Support 5 ms period for IMU explicitly

 -- Septentrio <githubuser@septentrio.com>  Wed, 09 Nov 2022 00:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.2-1buster) buster; urgency=high

  * Fixes
    
    Memory corruption under adverse conditions

 -- Septentrio <githubuser@septentrio.com>  Tue, 21 Jun 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.1-1buster) buster; urgency=high

  * New Features
    
    Add login credentials
    
    Activate NTP server if use_gnss_time is set to true
  * Improvements
    
    Add NED option to localization
  * Fixes
    
    IMU orientation for ROS axis convention
  * Commits
    
    Merge pull request #62 from thomasemter/dev/next
    Small fixes and additions
    
    Amend readme regarding robot_localization
    
    Add more explanations for IMU orientation in ROS convention
    
    Fix formatting in readme
    
    Fix package name in readme
    
    Update readme
    
    Update changelog
    
    Fix IMU orientation for ROS axis orientation
    
    Activate NTP only if GNSS time is used
    
    Add NED option to localization
    
    Set NMEA header to
    
    Fix logging causing crash
    
    Update readme and changelog
    
    Activate NTP server
    
    Add credentials for access control
    
    Contributors: Thomas Emter, Tibor Dome

 -- Septentrio <githubuser@septentrio.com>  Sun, 15 May 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.0-1buster) buster; urgency=high

  * New Features
    
    Add option to use ROS axis orientations according to REP103
    
    Add frame_id parameters
    
    Add option to get frames from tf
    
    Publishing of cartesian localization in UTM (topic and/or tf) for INS
    
    Publishing of IMU topic for INS
    
    Publishing of MeasEpoch
    
    ROS2 branch
  * Improvements
    
    Add multi antenna option
    
    Increase number of SBF streams
    
    Add option to set polling_period to "on change"
    
    Increased buffer size from 8192 to 131072 bytes
    
    Add endianess aware parsers
    
    Only publish topics set to true
    
    Add parameter to switch DEBUG logging on and off
    
    Change GPxxx messages to ROS built-in types
    
    Remove duplicate INS msg types
  * Fixes
    
    Setting of antenna type
    
    Publishing rate interconnections of gpsfix and velcovgeodetic
    
    Missing quotes for antenna type
    
    Broken attitude parsing pose and gpsfix from INS
    
    IMU orientation was not sent to Rx
    
    Graceful shutdown of threads
  * Commits
    
    Merge branch 'dev'
    
    Prepare new release
    
    Prepare new release
    
    Merge pull request #53 from thomasemter/dev/refactor
    Very last changes
    
    Add geographic lib dependency to package.xml
    
    Add comment for frame of main antenna
    
    Move utm zone locking section in readme
    
    Reformulate readme section on frames
    
    Merge pull request #52 from thomasemter/dev/refactor
    Last changes
    
    Change frame id back to poi_frame_id
    
    Make error log more explicit
    
    Merge pull request #49 from thomasemter/dev/refactor
    Improve IMU blocks sync and do-not-use value handling
    
    Fix buffer size in changelog
    
    Turn off Nagle's algorithm for TCP
    
    Fix changelog formatting
    
    Fix readme
    
    Set default base frame to base_link
    
    Fix valid tow check logic
    
    Increase buffer size for extreme stress tests
    
    Fix crc check
    
    Fix and streamline tf handling
    
    Add checks for validity of values
    
    Fix rad vs deg
    
    Update changelog
    
    Add some comments
    
    Set stdDevMask to values > 0.0 in node
    
    Set stdDevMask to values > 0.0
    
    Add info on RNDIS and set it to default
    
    Increase default serial baud rate
    
    Add parameter to set log level to debug
    
    Change defaults for publishers in node
    
    Put publish params together and fix mismatch in readme
    
    Improve IMU blocks sync and do-not-use value handling
    
    Merge pull request #48 from thomasemter/dev/refactor
    Fix measepoch not publishing without gpsfix
    
    Fix measepoch not publishing without gpsfix
    
    Merge pull request #47 from thomasemter/dev/refactor
    Dev/refactor
    
    Publish only messages set to true
    
    Remove leftover declaration
    
    Merge branch 'dev/endianess_agnostic' into dev/refactor
    
    Update readme to reflect endianess aware parsing
    
    Remove msg smart pointers
    
    Fix array assertion failure
    
    Cleanup
    
    Add ReceiverStatus parser
    
    Add QualityInd parser
    
    Add DOP parser
    
    Add ReceiverSetup parser
    
    Fix MeasEpoch and ChannelStatus parsers, add measepoch publishing
    
    Add ChannelStatus parser
    
    Add MeasEpoch parser
    
    Add IMU and VelSensor setup parsers
    
    Add Cov SBF parsers
    
    Add templated qi parser function
    
    Add AttEuler+Cov parser
    
    Revert ordering change inside INSNav ROS msgs
    
    Add ExtSensorMeas parser
    
    Add PVT parsers
    
    Add range checks to parsers
    
    Replace INSNav grammar with parsers
    
    Test parser vs. grammar for better performance
    
    Fix sb_list check
    
    Add IMU and VelSensor setup grammars
    
    Move adapt ROS header to typedefs.h
    


=== debian/control ===
Source: ros-noetic-septentrio-gnss-driver
Section: misc
Priority: optional
Maintainer: Septentrio <githubuser@septentrio.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-noetic-catkin, ros-noetic-cpp-common, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-gps-common, ros-noetic-message-generation, ros-noetic-nav-msgs, ros-noetic-nmea-msgs, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-rostime, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-xmlrpcpp
Homepage: https://github.com/septentrio-gnss/septentrio_gnss_driver
Standards-Version: 3.9.2

Package: ros-noetic-septentrio-gnss-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-noetic-cpp-common, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-gps-common, ros-noetic-message-runtime, ros-noetic-nav-msgs, ros-noetic-nmea-msgs, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-rostime, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-xmlrpcpp
Description: ROSaic: C++ driver for Septentrio's mosaic receivers and beyond

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-septentrio-gnss-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-septentrio-gnss-driver 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,17 @@
 cmake_minimum_required(VERSION 3.0.2)
 project(septentrio_gnss_driver)
 
-## Compile as C++14, supported in ROS Melodic and newer
-add_compile_options(-std=c++14)
+## Compile as C++17, supported in ROS Melodic and newer
+add_compile_options(-std=c++17)
+
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+message(STATUS "Setting build type to Release as none was specified.")
+set(CMAKE_BUILD_TYPE "Release" CACHE
+    STRING "Choose the type of build." FORCE)
+# Set the possible values of build type for cmake-gui
+set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
+  "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
+endif()
 
 ## Find catkin macros and libraries
 ## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
@@ -72,9 +81,13 @@
 ## Generate messages in the 'msg' folder
 add_message_files(
    FILES
+   AIMPlusStatus.msg
    BaseVectorCart.msg
    BaseVectorGeod.msg
    BlockHeader.msg
+   GALAuthStatus.msg
+   RFBand.msg
+   RFStatus.msg
    MeasEpoch.msg
    MeasEpochChannelType1.msg
    MeasEpochChannelType2.msg
@@ -176,21 +189,19 @@
 ## Declare a C++ executable
 ## With catkin_make all packages are built within a single CMake context
 ## The recommended prefix ensures that target names across packages don't collide
-add_executable(${PROJECT_NAME}_node 
-    src/septentrio_gnss_driver/node/main.cpp
-    src/septentrio_gnss_driver/node/rosaic_node.cpp
-    src/septentrio_gnss_driver/communication/circular_buffer.cpp 
-    src/septentrio_gnss_driver/parsers/parsing_utilities.cpp 
-    src/septentrio_gnss_driver/parsers/string_utilities.cpp 
-    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgga.cpp 
-    src/septentrio_gnss_driver/parsers/nmea_parsers/gprmc.cpp 
-    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsa.cpp 
-    src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsv.cpp 
-    src/septentrio_gnss_driver/crc/crc.cpp
-    src/septentrio_gnss_driver/communication/communication_core.cpp 
-    src/septentrio_gnss_driver/communication/rx_message.cpp 
-    src/septentrio_gnss_driver/communication/callback_handlers.cpp
-    src/septentrio_gnss_driver/communication/pcap_reader.cpp
+add_executable(${PROJECT_NAME}_node
+  src/septentrio_gnss_driver/communication/communication_core.cpp
+  src/septentrio_gnss_driver/communication/message_handler.cpp 
+  src/septentrio_gnss_driver/communication/telegram_handler.cpp
+  src/septentrio_gnss_driver/crc/crc.cpp
+  src/septentrio_gnss_driver/node/main.cpp
+  src/septentrio_gnss_driver/node/rosaic_node.cpp
+  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgga.cpp 
+  src/septentrio_gnss_driver/parsers/nmea_parsers/gprmc.cpp 
+  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsa.cpp 
+  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsv.cpp
+  src/septentrio_gnss_driver/parsers/parsing_utilities.cpp 
+  src/septentrio_gnss_driver/parsers/string_utilities.cpp  
 )
 
 ## Rename C++ executable without prefix

=== debian/changelog ===
ros-noetic-septentrio-gnss-driver (1.3.1-1focal) focal; urgency=high

  * New Features
    
    Recovery from connection interruption
    
    Add option to bypass configuration of Rx
    
    OSNMA
    
    Latency compensation for ROS timestamps
    
    Output of SBF block VelCovCartesian
    
    Support for UDP and TCP via IP server
    
    New VSM handling allows for unknown variances (INS firmware >= 1.4.1)
    
    Add heading angle to GPSFix msg (by diverting dip field, cf. readme)
  * Improvements
    
    Rework IO core and message handling
    * Unified stream processing
    * Internal data queue
    * Prevent message loss in file reading
    
    Add some explanatory warnings for parameter mismatches
    
    Add units to message definitions
  * Fixes
    
    navsatfix for INS
    
    Empty headers
    
    Single antenna receiver setup
  * Preliminary Features
    
    Output of localization and tf in ECEF frame, testing and feedback welcome

 -- Septentrio <githubuser@septentrio.com>  Wed, 05 Jul 2023 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.2.3-1focal) focal; urgency=high

  * New Features
    
    Twist output option
    
    Example config files for GNSS and INS
    
    Get leap seconds from receiver
    
    Firmware check
    
    VSM from odometry or twist ROS messages
    
    Add receiver type in case INS is used in GNSS mode
    
    Add publishing of base vector topics
  * Improvements
    
    Rework RTK corrections parameters and improve flexibility
  * Fixes
    
    /tf not being published without /localization
    
    Twist covariance matrix of localization
    
    Support 5 ms period for IMU explicitly

 -- Septentrio <githubuser@septentrio.com>  Wed, 09 Nov 2022 00:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.2-1focal) focal; urgency=high

  * Fixes
    
    Memory corruption under adverse conditions

 -- Septentrio <githubuser@septentrio.com>  Tue, 21 Jun 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.1-1focal) focal; urgency=high

  * New Features
    
    Add login credentials
    
    Activate NTP server if use_gnss_time is set to true
  * Improvements
    
    Add NED option to localization
  * Fixes
    
    IMU orientation for ROS axis convention
  * Commits
    
    Merge pull request #62 from thomasemter/dev/next
    Small fixes and additions
    
    Amend readme regarding robot_localization
    
    Add more explanations for IMU orientation in ROS convention
    
    Fix formatting in readme
    
    Fix package name in readme
    
    Update readme
    
    Update changelog
    
    Fix IMU orientation for ROS axis orientation
    
    Activate NTP only if GNSS time is used
    
    Add NED option to localization
    
    Set NMEA header to
    
    Fix logging causing crash
    
    Update readme and changelog
    
    Activate NTP server
    
    Add credentials for access control
    
    Contributors: Thomas Emter, Tibor Dome

 -- Septentrio <githubuser@septentrio.com>  Sun, 15 May 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.1.0-1focal) focal; urgency=high

  * New Features
    
    Add option to use ROS axis orientations according to REP103
    
    Add frame_id parameters
    
    Add option to get frames from tf
    
    Publishing of cartesian localization in UTM (topic and/or tf) for INS
    
    Publishing of IMU topic for INS
    
    Publishing of MeasEpoch
    
    ROS2 branch
  * Improvements
    
    Add multi antenna option
    
    Increase number of SBF streams
    
    Add option to set polling_period to "on change"
    
    Increased buffer size from 8192 to 131072 bytes
    
    Add endianess aware parsers
    
    Only publish topics set to true
    
    Add parameter to switch DEBUG logging on and off
    
    Change GPxxx messages to ROS built-in types
    
    Remove duplicate INS msg types
  * Fixes
    
    Setting of antenna type
    
    Publishing rate interconnections of gpsfix and velcovgeodetic
    
    Missing quotes for antenna type
    
    Broken attitude parsing pose and gpsfix from INS
    
    IMU orientation was not sent to Rx
    
    Graceful shutdown of threads
  * Commits
    
    Merge branch 'dev'
    
    Prepare new release
    
    Prepare new release
    
    Merge pull request #53 from thomasemter/dev/refactor
    Very last changes
    
    Add geographic lib dependency to package.xml
    
    Add comment for frame of main antenna
    
    Move utm zone locking section in readme
    
    Reformulate readme section on frames
    
    Merge pull request #52 from thomasemter/dev/refactor
    Last changes
    
    Change frame id back to poi_frame_id
    
    Make error log more explicit
    
    Merge pull request #49 from thomasemter/dev/refactor
    Improve IMU blocks sync and do-not-use value handling
    
    Fix buffer size in changelog
    
    Turn off Nagle's algorithm for TCP
    
    Fix changelog formatting
    
    Fix readme
    
    Set default base frame to base_link
    
    Fix valid tow check logic
    
    Increase buffer size for extreme stress tests
    
    Fix crc check
    
    Fix and streamline tf handling
    
    Add checks for validity of values
    
    Fix rad vs deg
    
    Update changelog
    
    Add some comments
    
    Set stdDevMask to values > 0.0 in node
    
    Set stdDevMask to values > 0.0
    
    Add info on RNDIS and set it to default
    
    Increase default serial baud rate
    
    Add parameter to set log level to debug
    
    Change defaults for publishers in node
    
    Put publish params together and fix mismatch in readme
    
    Improve IMU blocks sync and do-not-use value handling
    
    Merge pull request #48 from thomasemter/dev/refactor
    Fix measepoch not publishing without gpsfix
    
    Fix measepoch not publishing without gpsfix
    
    Merge pull request #47 from thomasemter/dev/refactor
    Dev/refactor
    
    Publish only messages set to true
    


## ros-noetic-septentrio-gnss-driver 1.4.2

=== debian/changelog ===
ros-noetic-septentrio-gnss-driver (1.4.2-1focal) focal; urgency=high

  * Merge branch 'peci1-patch-4'
  * Resolved merge conflict in msg/BlockHeader.msg
  * Merge pull request #144 <https://github.com/septentrio-gnss/septentrio_gnss_driver//issues/144> from thomasemter/master
    Export compiler directives and some minor changes
  * Merge pull request #141 <https://github.com/septentrio-gnss/septentrio_gnss_driver//issues/141> from peci1/patch-1
    Disable SBF/NMEA streams before executing user commands
  * Change unaligned INS publishing behavior
  * Update changelog
  * Update changelog
  * Fix namespace
  * Add missing declaration
  * Update changelog
  * A smoother ROS 1 experience for dual ROS 1 / 2 messages
  * Better handling of different ROS 1 and ROS 2 messages
  * Improve disconnection detection
  * Rework connection and shutwdown
  * Update changelog
  * Merge remote-tracking branch 'upstream/master'
  * Export directives
  * Disable SBF/NMEA streams before executing user commands
    This gives the possibility to configure additional streams in the user commands file.
  * Replace new
  * Add function to set vector to NaN and refactor parsing utilities
  * Add function to set quaternion to NaN
  * Remove msg to be copied
  * Fixes
    * Add export of compiler directives (thanks to @oysstu)
    * ROS 1 rebuild (thanks to @peci1)
  * Improvements
    * Rework TCP connection/reconnection
  * Changes
    * In case INS is not aligned yet but has GNSS heading, a valid orientation with roll and pitch = 0.0 will be published.
  * Contributors: Martin Pecka, Thomas Emter, @oysstu, septentrio-users

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Sat, 22 Feb 2025 00:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.4.1-1focal) focal; urgency=high

  * Fixes
    
    Lever arm calculation from tf
    
    NavSatStatus and GPSFixStatus
    
    Orientation in pose topic of GNSS

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Sat, 03 Aug 2024 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.4.0-1focal) focal; urgency=high

  * New features
    
    Send custom commands via ASCII file on startup
    
    Save config to boot after setup
    
    NTP and PTP server options (BREAKING: NTP is not setup automatically for use_gnss_time: true anymore)
    
    Receiver status on /diagnostics
    
    Option to publish only valid SBF block messages
    
    Option to auto publish available messages for configure_rx: false
  * Changes
    
    Change floating point do-not-use-values to NaN (BREAKING in case these values ae used for validity checks downstream)
    
    VSM now uses separate TCP device specified IP server
  * Improvements
    
    Rework some sections of the README
    
    Combine ROS 1 and ROS 2 in one branch
    
    Change GPSFix publishing policy to allow for high update rates

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Mon, 20 May 2024 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.3.2-1focal) focal; urgency=high

  * Merge pull request #106 <https://github.com/septentrio-gnss/septentrio_gnss_driver/issues/106> from thomasemter/dev/next2
    Fix IMU units
  * Fix topics namespace
  * Fix units of imu angular rates
  * Merge pull request #96 <https://github.com/septentrio-gnss/septentrio_gnss_driver/issues/96> from septentrio-gnss/dev2
    Dev2
  * Contributors: Thomas Emter, Tibor Dome, septentrio-users

 -- Septentrio <githubuser@septentrio.com>  Sun, 19 Nov 2023 00:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.2.2-1focal) focal; urgency=high

  * Fixes
    
    Memory corruption under adverse conditions
  * Commits
    
    Merge pull request #66 from thomasemter/dev/next2
    Fix memory corruption
    
    Fix parameter warnings
    
    Reset buffer size to 16384
    
    Update changelog
    
    Fix memory corruption
    
    Replace maps with unordered_maps
    
    Overload timestamp function
    
    Fix frame ids for INS msgs
    
    Add define to avoid usage of deprecated header
    
    Change readme on gps-msgs packet
    
    Add info on user credentials
    
    Fix spelling in readme
    
    Merge remote-tracking branch 'upstream/ros2' into dev/next2
    
    Add comment for heading from pose
    
    Contributors: Thomas Emter, Tibor Dome

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Tue, 21 Jun 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.2.1-1focal) focal; urgency=high

  * New Features
    
    Add login credentials
    
    Activate NTP server if use_gnss_time is set to true
  * Improvements
    
    Add NED option to localization
  * Fixes
    
    IMU orientation for ROS axis convention
  * Commits
    
    Merge pull request #63 from thomasemter/dev/next2
    Small fixes and additions
    
    Merge pull request #60 from wep21/support-rolling
    fix: modify build error for rolling/humble
    
    Revert change for deprecation warning in Humble
    
    Change links to reflect ROS2
    
    Amend readme regarding robot_localization
    
    Fix compiler warnings for humble
    
    Add more explanations for IMU orientation in ROS convention
    
    Fix formatting in readme
    
    Fix package name in readme
    
    Update readme
    
    Update changelog
    
    Fix IMU orientation for ROS axis orientation
    
    Activate NTP only if GNSS time is used
    
    Add NED option to localization
    
    Set NMEA header to GP
    
    Update readme and changelog
    
    Activate NTP server
    
    Add credentials for access control
    
    fix: modify build error for rolling/humble
    
    Contributors: Daisuke Nishimatsu, Thomas Emter, Tibor Dome

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Sun, 15 May 2022 23:00:00 -0000

ros-noetic-septentrio-gnss-driver (1.2.0-1focal) focal; urgency=high

  * New Features
    
    Add option to use ROS axis orientations according to REP103
    
    Add frame_id parameters
    
    Add option to get frames from tf
    


=== debian/control ===
Source: ros-noetic-septentrio-gnss-driver
Section: misc
Priority: optional
Maintainer: Tibor Dome <tibor.doeme@alumni.ethz.ch>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-noetic-catkin, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-gps-common, ros-noetic-message-generation, ros-noetic-nav-msgs, ros-noetic-nmea-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Homepage: https://github.com/septentrio-gnss/septentrio_gnss_driver
Standards-Version: 3.9.2

Package: ros-noetic-septentrio-gnss-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-gps-common, ros-noetic-message-runtime, ros-noetic-nav-msgs, ros-noetic-nmea-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Description: ROSaic: C++ driver for Septentrio's GNSS and INS receivers
